/*
 * fookb.c
 *
 * (c) 1998,99 Alexey Vyskubov <alexey@alv.stud.pu.ru>
 */

#include <stdlib.h> /* malloc() */
#include <stdio.h>  /* puts() */

/* Headers for gentleman */
#include <X11/Xlib.h>
#include <X11/Xutil.h>

/* XKB fun */
#include <X11/XKBlib.h>

/* Xpm fun */
#include <X11/xpm.h>

/* My own fun */
#include "fookb.h"


int main (int argc, char ** argv)
{
    int * event_rtrn;	/* stupid things for XkbOpenDisplay */
    int * error_rtrn;
    int * reason_rtrn;
    
    XkbEvent labuda;	/* Xkb event. X event will be labuda.core */
    
    Window billy;		/*   _The_ Window  */

#ifdef WMAKER
    Window dilly;		/* ...and his icon */
#endif
    
    int border=0;		/* _The_ Window parameters */
    unsigned int wth=48;	/* Well, you know */
    unsigned int hth=48;
    
    XWMHints * wm_hints;
    XClassHint class_hints;

#ifdef WMAKER			/* If we use Windowmaker, _The_ Window will */
    XSizeHints * BigBunny;	/* be withdrawn. We do not want to place 
				 * empty border by hand. */
#endif
  
    GC gc;			/* Graphic context */
    
    char resn[]="fookb";
    char resc[]="Fookb";
    
    int state=0;		/* We suppose that latin keyboard is the
				   primal state FIXME*/
    
    event_rtrn = malloc(sizeof(int)); /* Never used malloc before :) */
    error_rtrn = malloc(sizeof(int));
    reason_rtrn = malloc(sizeof(int));
    
/* Go, fighters, go! */
    dpy = XkbOpenDisplay( "",
			  event_rtrn,
			  error_rtrn,
			  NULL,
			  NULL,
			  reason_rtrn); 
    
/* Oops. */
    if (dpy==NULL) {puts("Oops."); exit(-1);}
    
    scr = DefaultScreen(dpy);
    root = RootWindow(dpy, scr);
    
/* We would like receive the only Xkb event: XkbStateNotify. And only
 * when XkbLockGroup happens. */
    XkbSelectEventDetails(dpy, XkbUseCoreKbd, XkbStateNotify, 0xFFF, XkbGroupLockMask);
    
/* Run out! */
    billy = XCreateSimpleWindow( dpy,
				 root,
				 0, 0,
				 wth, hth,
				 border,
				 BlackPixel(dpy, scr),
				 WhitePixel(dpy, scr));
    
#ifdef WMAKER
    dilly = XCreateSimpleWindow( dpy,
				 root,
				 0, 0,
				 wth, hth,
				 border,
				 BlackPixel(dpy, scr),
				 WhitePixel(dpy, scr));
#endif
    
    
    class_hints.res_name  = resn; 
    class_hints.res_class = resc;
    
    XSetClassHint(dpy, billy, &class_hints);
    
    wm_hints = XAllocWMHints();
    wm_hints->window_group = billy;

#ifdef WMAKER
    wm_hints->icon_window  = dilly;
#endif
    
    wm_hints->input = False;
    wm_hints->flags = InputHint | WindowGroupHint;
    
#ifdef WMAKER
    wm_hints->flags = wm_hints->flags | IconWindowHint;
    XSetWMHints(dpy, dilly, wm_hints);
    wm_hints->initial_state = WithdrawnState;
    wm_hints->flags = wm_hints->flags | StateHint;
#endif
    
    XSetWMHints(dpy, billy, wm_hints);
    
#ifdef WMAKER /* Look at the comment for XSizeHonts * BigBunny */
    BigBunny = XAllocSizeHints();
/* Nasty Hack. XSizeHints.x & XSizeHints.y are obsolete. */
    BigBunny->x = 0;
    BigBunny->y = 0;
    BigBunny->flags = PPosition;
    XSetWMNormalHints(dpy, billy, BigBunny);
#endif
    
/* The only thing we would like to do - update our billy */
#ifndef WMAKER
    XSelectInput(dpy, billy, ExposureMask | ButtonPressMask);
#else /* ...or dilly?! */
    XSelectInput(dpy, dilly, ExposureMask | ButtonPressMask);
#endif
    
    XSetCommand(dpy, billy, argv, argc);
    
/* Programmer supplied functions */
#ifndef WMAKER
    getGC(billy, &gc);
#else
    getGC(dilly, &gc);
#endif
  
    read_images();
/* */
    
/* Let's look */
    XMapWindow(dpy, billy); /* We would like to see the window. */
    
/* HELLO! HELLO! HELLO! Is that our GOOD FRIEND main loop here? */
    while (1) {
	XNextEvent(dpy, &labuda.core);
	switch (labuda.core.type) {
	    
	case Expose:	/* We should update our window. */
	    if (labuda.core.xexpose.count != 0)
		/* Well, I knew what does it mean,
		   but I forgot :) */
		break;
#ifndef WMAKER
	    update_window(billy, gc, state);
#else
	    update_window(dilly, gc, state);
#endif
	    break;
	case ButtonPress:
	    
	    switch (labuda.core.xbutton.button) {
	    case Button1:
#ifdef DEBUG
		puts("Button1 pressed.");
#endif
		XkbLockGroup(dpy,
			     XkbUseCoreKbd,
			     (state + 1) % 4);
		break;
	    case Button2:
#ifdef DEBUG
		puts("Button2 pressed.");
#endif
		XkbLockGroup(dpy,
			     XkbUseCoreKbd,
              (state + 3) % 4);
		break;
	    case Button3:
#ifdef DEBUG
		puts("Button3 pressed, bye.");
#endif
		XFreeGC(dpy,gc);
		XDestroyWindow(dpy,billy);
#ifdef WMAKER
		XDestroyWindow(dpy,dilly);
#endif
		XCloseDisplay(dpy);
		exit(0);
	    }
	    break;
	default: /* XkbLockGroup happens : FIXME*/
	    state = labuda.state.group;
#ifdef DEBUG
	    printf("%u\n", state);
#endif
	    
	    if ((state < 0) || (state > 4)) state = 4;
	    
#ifndef WMAKER
	    update_window(billy, gc, state);
#else
	    update_window(dilly, gc, state);
#endif
	    
#ifdef DEBUG
	    puts(".");	/* XkbLockGroup happens */
#endif
	}
    }
    
    return(0); /* Bye! Never coming back for no more. */ /* FIXME */
}

void getGC(win, gc)
    Window win;
    GC * gc;
{
    unsigned long valuemask=0; /* No data in ``values'' */
    XGCValues values;
    *gc = XCreateGC(dpy, win, valuemask, &values);
/*	XSetForeground(dpy, *gc, BlackPixel(dpy, scr)); */
}

int get_one_image(name, index)
    char * name;
    int index;
{
    int foo;
    
    foo = XpmReadFileToImage(dpy, name, &stupid_picture[index],
			     NULL, NULL);
    return(foo);
}

void read_images()
{
    int i;
    int res;
    int status = 0;

    for(i=0;i<5;i++) {
	
	switch (i) {
	case 0:
	    res = get_one_image( XPM1, 0 );
	    break;
	case 1:
	    res = get_one_image( XPM2, 1 );
	    break;
	case 2:
	    res = get_one_image( XPM3, 2 );
	    break;
	case 3:
	    res = get_one_image( XPM4, 3 );
	    break;
	default:
	    res = get_one_image( BOOM, 4 );
	    break;
	}
	
	switch (res) {
	case XpmOpenFailed:
	    puts("Xpm file open failed:");
	    status = 1 << 5;
	    break;
	case XpmFileInvalid:
	    puts("Xpm file is invalid:");
	    status = 1 << 6;
	    break;
	case XpmNoMemory:
	    puts("No memory for open xpm file:");
	    status = 1 << 7;
	    break;
	default:
	}

	if (!(status == 0)) {
	    status += 1 << i;
	    switch (i) {
	    case 0:
		puts(XPM1);
		break;
	    case 1:
		puts(XPM2);
		break;
	    case 2:
		puts(XPM3);
		break;
	    case 3:
		puts(XPM4);
		break;
	    case 4:
		puts(BOOM);
		break;
	    default:
		puts("UNKNOWN ERROR! PLEASE REPORT!!!");
		exit(-2);
	    }
	    exit(status);
	}
    }
		    
}

void update_window(win, gc, whattodo)
    Window win;
    GC gc;
    unsigned int whattodo;
{
    XPutImage(dpy, win, gc, stupid_picture[whattodo], 0, 0, 0, 0, 48, 48);
}
